package drawFramePackage;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.ListIterator;
import java.util.Random;
import java.util.TimerTask;
import javax.imageio.ImageIO;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.Timer;
/** tower defense video game for $299.99 computer. nathaniel first java program. as time go on, more enemy spawn.
 * @author nathaniel victor nelson
 * @since 2012
 */
public class towerdefensecasper extends JPanel implements ActionListener, MouseListener, MouseMotionListener{
	/**
	 *
	 */
	private static final long serialVersionUID = 1L;
	/** frame that hold game */
	JFrame j;
	/** spawn enemy once in a while */
	Timer t;
	/** increase level periodicly */
	Timer t2;
	/** display new level */
	Timer t3;
	/** player mouse point */
	Point mouseLocation;
	MathContext mc;
	BigDecimal rounder;
	/** used to draw in paintcomponent method */
	Graphics2D g2d;
	AudioInputStream stream;
	AudioFormat format;
	DataLine.Info dlInfo;
	/** video game sound efect */
	Clip clickingPlayButton, hoverSound, otherMainButtons, clickingTowerButton, towerHoverSound, 
	towerDropSound, towerSound, frostShotSound, poisenShotSound, splashShotSound, towerHitSound, 
	frostHitSound, poisenHitSound, poiseningSound, voiceExplosion, peasentHitSound, 
	peasentDeathSound, bombAttackingAndDeathSound, knightHitSound, horsemanDyingSound, 
	drillerAttackingSound, drillerDyingSound, bossAttackingSound, bossDying, gateExplosionSound, 
	titleScreenSong, playingSong, creditsSong;
	/** sound efect list. game might be writen poorly */
	Clip clickingPlayButtonArray[] = {clickingPlayButton, hoverSound, otherMainButtons, 
			clickingTowerButton, towerHoverSound, towerDropSound, towerSound, frostShotSound, 
			poisenShotSound, splashShotSound, towerHitSound, frostHitSound, poisenHitSound, 
			poiseningSound, voiceExplosion, peasentHitSound, peasentDeathSound, 
			bombAttackingAndDeathSound, knightHitSound, horsemanDyingSound, 
			drillerAttackingSound, drillerDyingSound, bossAttackingSound, bossDying, 
			gateExplosionSound, titleScreenSong, playingSong, creditsSong};
	/** sound efect or music .mid file name to be loaded */
	String sounds[] = {"clickingPlayButton.wav", "hoverSound.wav", "otherMainButtons.wav", 
			"clickingTowerButton.wav", "towerHoverSound.wav", "towerDropSound.wav", 
			"towerSound.wav", "frostShot.wav", "poisenShotSound.wav", "splashShotSound.wav", 
			"towerHitSound.wav", "frostHitSound.wav", "poisenHitSound.wav", "poiseningSound.wav", 
			"voiceExplosion.wav", "peasentHitSound.wav", "peasentDeathSound.wav", 
			"bombAttackingAndDeathSound.wav", "knightHitSound.wav", "horsemanDyingSound.wav", 
			"drillerAttackingSound.wav", "drillerDyingSound.wav", "bossAttacking.wav", 
			"bossDying.wav", "gateExplosionSound.wav", "titlescreen.mid", "playing.mid", 
			"credits.mid"};
	AffineTransform playLocation, creditsButtonLocation, backButtonLocation, authorLocation, 
	pauseButtonLocation;
	Integer quad2, whichShot, rand, gh, recSpacing, gold, towerCost, speedTowerCost, 
	poisenTowerCost, frostTowerCost, splashTowerCost, level, peasentHealth, walkingBombHealth, 
	knightHealth, peasentsAttackDamage, bombsAttackDamage, knightsAttackDamage, 
	doorSmasherHealth, bossHealth, doubleHealth, spacing, healthAddition, attackDamage, 
	bossAttackDamage, onesAndZeros, t1Time, t1Time2, t1Placeholder2, t2Time, t2Time2, 
	t2Placeholder2, t3Time, t3Time2, t3Placeholder2;
	Integer forTimers[] = {onesAndZeros, t1Time, t1Time2, t1Placeholder2, t2Time, t2Time2, 
			t2Placeholder2, t3Time, t3Time2, t3Placeholder2};
	Double slope2, speed, roundedNumber;
	Integer enemyPerspective[];
	Rectangle buildAreaOne, buildAreaTwo, mouseLocationRectangle, playButtonRectangle, 
	retryButtonRectangle, instructionsButtonRectangle, creditsButtonRectangle,
	backButtonRectangle, soundRectangle, musicRectangle, pauseRectangle, pausedRectangle;
	Rectangle2D.Double rec, rec2, rec3, rec4, rec5;
	/** tower rectangle background aray for colision */
	Rectangle2D.Double recArray[] = {rec, rec2, rec3, rec4, rec5};
	Boolean clickedTower, skipIt, poisenClicked, splashClicked, needsTsRemoved, fTClicked, 
	speedTowerClicked, displayingLevel, titleScreenBoolean, playing, bossIsDead, watchingCredits, 
	instructionsScreenBoolean, hasPlayedHoverSound, sound, music, paused, t1HasFired,
	t2HasFired, t3HasFired, t2HasStarted;
	ImageIcon explosion, enemy1, enemy1D, enemy1A, enemy1Poisened, enemy1Frozen, enemy1Burning, 
	walkingBomb, walkingBombExplosionAndDeath, horsemanAnimatedSmall, horseManDeath,
	horseRetreating, horsemanAttackingSmall, knightPoisenAnimation, knightFrostAnimation,
	knightFireAnimation, doorSmasherAnimation, sparks2, doorSmasherAttacking, doorSmasherDeath, 
	doorSmasherPoisened, doorSmasherFrozen, doorSmasherBurning, boss, bossAttacking, bossDeath, 
	gateExplosion;
	/** video game animation list */
	ImageIcon iIL[] = {explosion, enemy1, enemy1D, enemy1A, enemy1Poisened, enemy1Frozen, 
			enemy1Burning, walkingBomb, walkingBombExplosionAndDeath, horsemanAnimatedSmall, 
			horseManDeath, horseRetreating, horsemanAttackingSmall, knightPoisenAnimation, 
			knightFrostAnimation, knightFireAnimation, doorSmasherAnimation, sparks2, 
			doorSmasherAttacking, doorSmasherDeath, doorSmasherPoisened, doorSmasherFrozen, 
			doorSmasherBurning, boss, bossAttacking, bossDeath, gateExplosion};
	/** video game animation file name to be loaded */
	String iIN[] = {"explosion.gif", "enemy1.gif", "enemy1D.gif", "enemy1A.gif", 
			"poisenAnimation.gif", "frost.gif", "fireAnimation.gif", "walkingBomb.gif", 
			"walkingBombExplosionAndDeath.gif", "horsemanAnimatedSmall.gif", "horseManDeath.gif", 
			"horseRetreatingSmall.gif", "horsemanAttackingSmall.gif", 
			"knightPoisenAnimation.gif", "knightFrostAnimation.gif", "knightFireAnimation.gif", 
			"doorSmasherAnimationSmall.gif", "sparks.gif", "doorSmasherAttacking.gif", 
			"doorSmasherDeath.gif", "doorSmasherPoisened.gif", "doorSmasherFrozen.gif", 
			"doorSmasherBurning.gif", "hammerRobotAnimationSmall.gif", 
			"robotAttackingSmall.gif", "hammerRobotDeathAnimationSmall.gif", "gateExplosion.gif"};
	/** in game background */
	BufferedImage b;
	BufferedImage towerIcon, towerShot, frostTower, frostShot, poisenTower, poisenShot, 
	splashTower, splashShot, tree, cliff, cliff2, gate, speedTower, towerIconHighlighted, 
	speedTowerHighlighted, poisenTowerHighlighted, frostTowerHighlighted, splashTowerHighlighted, 
	speedShot, towerInfo, speedTowerInfo, poisenTowerInfo, frostTowerInfo, splashTowerInfo, 
	info, ex1, ex2, ex3, ex4, ed1, ed2, ed3, ed4, bd1, bd2, bd3, bd4, kd1, kd2, kd3, kd4, ds1,
	ds2, ds3, ds4, titleScreen, play2, playHightlighted3, creditsButton,
	creditsButtonHighlighted, instructions, instructionsHighlighted, instructionsScreen, back,
	backHighlighted, tdCredits, author, retry, retryHighlighted, soundI, musicI, noSound, 
	noMusic, pauseImage, pausedImage, pauseHighlighted, pausedHighlighted, soundHighlighted, 
	musicHighlighted;
	/** game image list */
	BufferedImage bIL[] = {splashTower, splashShot, poisenTower, poisenShot, frostTower, 
			frostShot, splashTower, splashShot, b, cliff, cliff2, towerIcon, towerShot, tree, 
			gate, speedTower, towerIconHighlighted, speedTowerHighlighted, 
			poisenTowerHighlighted, frostTowerHighlighted, splashTowerHighlighted, speedShot, 
			towerInfo, speedTowerInfo, poisenTowerInfo, frostTowerInfo, splashTowerInfo, info, 
			ex1, ex2, ex3, ex4, ed1, ed2, ed3, ed4, bd1, bd2, bd3, bd4, kd1, kd2, kd3, kd4, ds1, 
			ds2, ds3, ds4, titleScreen, play2, playHightlighted3, creditsButton, 
			creditsButtonHighlighted, instructions, instructionsHighlighted, instructionsScreen, 
			back, backHighlighted, tdCredits, author, retry, retryHighlighted, soundI, musicI, 
			noSound, noMusic, pauseImage, pausedImage, pauseHighlighted, pausedHighlighted, 
			soundHighlighted, musicHighlighted};
	/** game image to be loaded */
	String bIN[] = {"splashTower2.png", "splashShot2.png", "poisenTower2.png", "poisenShot2.png", 
			"frostTower2.png", "frostShot2.png", "splashTower2.png", "splashShot2.png", 
			"GrassWaterCliff2.jpg", "cliff.png", "cliff2.png", "basicTower2.png", 
			"towerShot2.png", "tree46.png", "gate2.png", "speedTower3.png",
			"basicTower2Highlighted.png", "speedTower3Highlighted.png",
			"poisenTower2Highlighted.png", "frostTower2Highlighted.png",
			"splashTower2Highlighted.png", "speedTowerShot2.png", "towerInfo.png",
			"speedTowerInfo.png", "poisenTowerInfo.png", "frostTowerInfo.png", 
			"splashTowerInfo.png", "info.png", "nEF1.png", "nEF2.png", "nEF3.png", "nEF4.png",
			"ed1.png", "ed2.png", "ed3.png", "ed4.png", "bd1.png", "bd2.png", "bd3.png", 
			"bd4.png", "kd1.png", "kd2.png", "kd3.png", "kd4.png", "ds1.png", "ds2.png",
			"ds3.png", "ds4.png", "titleScreen.png", "play2.png", "playHighlighted3.png", 
			"creditsButton.png", "creditsButtonHighlighted.png", "instructions.png", 
			"instructionsHighlighted.png", "instructionsScreen.png", "back.png", 
			"backHighlighted.png", "tdCredits.png", "author.gif", "retry.png",
			"retryHighlighted.png", "sound.png", "music.png", "noSound.png", "noMusic.png", 
			"pause.png", "resume.png", "pauseHighlighted.png", "resumeHighlighted.png", 
			"soundHighlighted.png", "musicHighlighted.png"};
	/** enemy in the game. four type of enemy and one boss enemy */
	ArrayList<enemys> enemyList;
	/** used to iterate through enemylist */
	ListIterator<enemys> li;
	/** player tower list */
	ArrayList<structure> structureList;
	ListIterator<structure> slLi;
	/** player tower shot */
	ArrayList<towerShot> towerShotList;
	ListIterator<towerShot> towerShotListLi;
	/** broken on main game menu */
	ArrayList<hoverAndClickSounds> hACSounds;
	ListIterator<hoverAndClickSounds> hACSoundsLi;
	/**
	 * @param args
	 * @throws IOException
	 * @throws UnsupportedAudioFileException
	 * @throws LineUnavailableException
	 */
	public static void main(String[] args) throws IOException, UnsupportedAudioFileException,
	LineUnavailableException {
		new towerdefensecasper();
	}
	/** tower defense */
	@SuppressWarnings("deprecation")
	public towerdefensecasper() throws IOException, UnsupportedAudioFileException, LineUnavailableException{
		// read image to bufered image from string list
		for (int i = 0; i <= bIL.length - 1; i++){
			bIL[i] = ImageIO.read(new File(bIN[i]));
		}
		for (int i = 0; i <= iIL.length - 1; i++){
			iIL[i] = new ImageIcon(iIN[i]);
		}
		recSpacing = new Integer(10 + bIL[27].getWidth());
		for (int i = 0; i <= recArray.length - 1; i++){
			recArray[i] = new Rectangle2D.Double(recSpacing, 10, 70, 70);
			recSpacing += 80;
		}
		// load sound / music
		for (int i = 0; i <= clickingPlayButtonArray.length - 1; i++){
			stream = AudioSystem.getAudioInputStream(new File(sounds[i]));
			format = stream.getFormat();
			dlInfo = new DataLine.Info(Clip.class, format);
			clickingPlayButtonArray[i] = (Clip) AudioSystem.getLine(dlInfo);
			clickingPlayButtonArray[i].open(stream);
		}
		// might need recode
		for (int i = 0; i < forTimers.length; i++){
			forTimers[i] = new Integer(0);
		}
		forTimers[1] = (int) System.currentTimeMillis();
		clickingPlayButtonArray[25].loop(Clip.LOOP_CONTINUOUSLY);
		// initialize variable
		mc = new MathContext(1, RoundingMode.HALF_UP);
		playLocation = new AffineTransform(1, 0, 0, 1, 700, 300);
		creditsButtonLocation = new AffineTransform(1, 0, 0, 1, 150, 285);
		backButtonLocation = new AffineTransform(1, 0, 0, 1, 15, 15);
		pauseButtonLocation = new AffineTransform(1, 0, 0, 1, 10, 584);
		playButtonRectangle = new Rectangle((int)playLocation.getTranslateX(),
				(int)playLocation.getTranslateY(), bIL[49].getWidth(), bIL[49].getHeight());
		instructionsButtonRectangle = new Rectangle((int)playLocation.getTranslateX(), 
				(int)playLocation.getTranslateY() + bIL[49].getHeight() + 25, 
				bIL[53].getWidth(), bIL[53].getHeight());
		backButtonRectangle = new Rectangle((int)backButtonLocation.getTranslateX(), 
				(int)backButtonLocation.getTranslateY(), bIL[56].getWidth(), bIL[56].getHeight());
		retryButtonRectangle = new Rectangle(75, 290, bIL[60].getWidth(), bIL[60].getHeight());
		creditsButtonRectangle = new Rectangle((int)creditsButtonLocation.getTranslateX(), 
				(int)creditsButtonLocation.getTranslateY(), bIL[51].getWidth(),
				bIL[51].getHeight()); //955
		soundRectangle = new Rectangle(925, 10, bIL[62].getWidth(), bIL[62].getHeight());
		musicRectangle = new Rectangle(1060, 10, bIL[63].getWidth(), bIL[63].getHeight());
		pauseRectangle = new Rectangle((int)pauseButtonLocation.getTranslateX(), 
				(int)pauseButtonLocation.getTranslateY(), bIL[66].getWidth(),
				bIL[66].getHeight());
		pausedRectangle = new Rectangle((int)pauseButtonLocation.getTranslateX(), 
				(int)pauseButtonLocation.getTranslateY(), bIL[67].getWidth(),
				bIL[67].getHeight());
		speed = new Double(.1);
		attackDamage = new Integer(15);
		bombsAttackDamage = new Integer(1500);
		bossAttackDamage = new Integer(225);
		peasentHealth = new Integer(30);
		walkingBombHealth = new Integer(40);
		knightHealth = new Integer(72);
		doorSmasherHealth = new Integer(106);
		bossHealth = new Integer(38490);
		level = new Integer(1);
		towerCost = new Integer(50);
		speedTowerCost = new Integer(500);
		poisenTowerCost = new Integer(900);
		frostTowerCost = new Integer(250);
		splashTowerCost = new Integer(900);
		mouseLocation = new Point();
		gold = new Integer(50);
		spacing = new Integer(0);
		healthAddition = new Integer(2);
		hasPlayedHoverSound = new Boolean(false);
		displayingLevel = new Boolean(false);
		instructionsScreenBoolean = new Boolean(false);
		bossIsDead = new Boolean(false);
		watchingCredits = new Boolean(false);
		mouseLocationRectangle = new Rectangle(1, 1);
		clickedTower = new Boolean(false);
		speedTowerClicked = new Boolean(false);
		skipIt = new Boolean(false);
		poisenClicked = new Boolean(false);
		splashClicked = new Boolean(false);
		needsTsRemoved = new Boolean(false);
		fTClicked = new Boolean(false);
		titleScreenBoolean = new Boolean(true);
		playing = new Boolean(false);
		sound = new Boolean(true);
		music = new Boolean(true);
		paused = new Boolean(false);
		t1HasFired = new Boolean(true);
		t2HasFired = new Boolean(false);
		t3HasFired = new Boolean(false);
		t2HasStarted = new Boolean(false);
		gh = new Integer(750000);
		enemyList = new ArrayList<enemys>();
		structureList = new ArrayList<structure>();
		towerShotList = new ArrayList<towerShot>();
		hACSounds = new ArrayList<hoverAndClickSounds>();
		buildAreaOne = new Rectangle(665, 0, 535, 95);
		buildAreaTwo = new Rectangle(718, 370, 480, 96);
		j = new JFrame("Tower Defense");
		j.setIconImage(towerIcon);
		j.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		j.setSize(new Dimension(1216, 688));
		j.setVisible(true);
		j.add(this);
		j.addMouseMotionListener(this);
		j.addMouseListener(this);
		authorLocation = new AffineTransform(1, 0, 0, 1, j.getWidth() / 2
				- bIL[59].getWidth() / 2, j.getHeight());
		t = new Timer(24000, this);
		t2 = new Timer(48000, this);
		t3 = new Timer(4000, this);
	}
	
	/** handle enemy animation
	 * @see enemys */
	public void handleenemyanimation() {
		enemyList = arrangeNumbers(enemyList);
		li = enemyList.listIterator();
		while (li.hasNext()){
			enemys enemysClass = li.next();
			if (enemysClass.attacking.getLongFramePosition()
					== enemysClass.attacking.getFrameLength()){
				enemysClass.attacking.setFramePosition(0);
			}
			if (enemysClass.enemyNumber != 1 && enemysClass.dying.getLongFramePosition()
					== enemysClass.dying.getFrameLength()){
				enemysClass.dying.setFramePosition(0);
			}
			if (enemysClass.enemyNumber == 4){
			//System.out.println(enemysClass.aff.getTranslateX());
			}
			if (enemysClass.flaggedForRemoval){
				if (enemysClass.enemyNumber == 2 && enemysClass.aff2.getTranslateX() <=
						-iIL[11].getIconWidth()){
					li.remove();
				}
				if (enemysClass.enemyNumber != 2){
					li.remove();
				}
			}
			if (enemysClass.isDying){
				if (enemysClass.enemyNumber == 4){
						enemysClass.enemyDeath.paintIcon(this, g2d, 
								(int)enemysClass.aff.getTranslateX(), 
								(int)enemysClass.aff.getTranslateY());
						bossIsDead = true;
					}
				else{
					if (enemysClass.enemyNumber == 2 && enemysClass.aff2.getTranslateX() > 
						-enemysClass.horseRetreating.getIconWidth()){
						enemysClass.horseRetreating.paintIcon(this, g2d, 
							(int)enemysClass.aff2.getTranslateX(), 
							(int)enemysClass.aff2.getTranslateY());
						if (!paused){
						enemysClass.aff2.translate(-1, 0);
						}
					}
				if (enemysClass.enemyNumber != 1){
					g2d.drawImage(bIL[enemysClass.whichFrame], new AffineTransform(1, 0, 0, 1, 
							enemysClass.aff.getTranslateX(), enemysClass.aff.getTranslateY()),
							this);
				}
				if (enemysClass.enemyNumber == 1 && enemysClass.fourCount != 4){
					g2d.drawImage(bIL[enemysClass.whichFrame], new AffineTransform(1, 0, 0, 1, 
							enemysClass.aff.getTranslateX(), enemysClass.aff.getTranslateY()),
							this);
				}
				if (enemysClass.explodedOnGate != true && enemysClass.enemyNumber != 4){
					g2d.setColor(Color.BLUE);
					g2d.drawString("+" + enemysClass.goldAward + "g", 
						(int)enemysClass.aff.getTranslateX(), 
						(int)enemysClass.aff.getTranslateY());
					}
				}
			}
			else{
			if (enemysClass.isFrozen && new Random().nextInt(25) == 0){
			enemysClass.enemyFrozen.paintIcon(this, g2d, (int)enemysClass.aff.getTranslateX(), 
					(int)enemysClass.aff.getTranslateY());
			}
			if (enemysClass.isBurning && new Random().nextInt(25) == 0){
			enemysClass.enemyBurning.paintIcon(this, g2d, (int)enemysClass.aff.getTranslateX(),
						(int)enemysClass.aff.getTranslateY());
			}
			if (enemysClass.isPoisened && new Random().nextInt(25) == 0){
			enemysClass.enemyPoisened.paintIcon(this, g2d, (int)enemysClass.aff.getTranslateX(), 
					(int)enemysClass.aff.getTranslateY());
			}
			if (enemysClass.aff.getTranslateX() > 1143 - 
					enemysClass.enemyAttacking.getIconWidth() && gh > 0){
			if (enemysClass.enemyNumber == 1 && enemysClass.explodedOnGate != true){
				if (gh - bombsAttackDamage > 0){
					gh -= bombsAttackDamage;
				}
				else{
					gh = 0;
				}
					enemysClass.attacking.start();
					enemysClass.explodedOnGate = true;
					enemysClass.isDying = true;
					enemysClass.t2.start();
			}
			if (enemysClass.enemyNumber != 1){
				if (enemysClass.timerScheduled != true){
				enemysClass.t3.schedule(enemysClass, 840, 0);
				enemysClass.timerScheduled = true;
				}
				enemysClass.enemyAttacking.paintIcon(this, g2d, 
						(int)enemysClass.aff.getTranslateX(), 
						(int)enemysClass.aff.getTranslateY());
				if (!paused){
				if (gh - attackDamage > 0 && enemysClass.enemyNumber != 4){
					gh -= attackDamage;
				}
				if (gh - attackDamage < 1){
					gh = 0;
				}
				if (enemysClass.enemyNumber == 4 && gh - bossAttackDamage > 0){
					gh -= bossAttackDamage;
				}
				if (gh - bossAttackDamage < 1){
					gh = 0;
				}
				}
			}
			if (enemysClass.enemyNumber == 3 && new Random().nextInt(25) == 0){
				enemysClass.sparks.paintIcon(this, g2d, (int)enemysClass.aff.getTranslateX() + 
						enemysClass.enemyAttacking.getIconWidth() - 
						enemysClass.sparks.getIconWidth(), (int)enemysClass.aff.getTranslateY() + 
						enemysClass.enemyAttacking.getIconHeight() - 
						enemysClass.sparks.getIconHeight() - 8);
				}
			}
			//1068.000000000129 - 75 =
			// 1143 - 75 = 1068
			if (enemysClass.aff.getTranslateX() <= 1143 - 
					enemysClass.enemyAttacking.getIconWidth() || gh < 1){
				if (!paused){
			enemysClass.aff.translate(enemysClass.speed - enemysClass.frostNumber, 0);
			enemysClass.rec.x = enemysClass.aff.getTranslateX();
				}
				if (new Random().nextInt(25) == 0) {
			enemysClass.enemyImage.paintIcon(this, g2d, (int)enemysClass.aff.getTranslateX(), 
					(int)enemysClass.aff.getTranslateY());
				}
			//System.out.println(enemysClass.aff.getTranslateX());
			if (enemysClass.aff.getTranslateX() >= j.getWidth()){
				li.remove();
					}
				}
			}
		}
	}
	/** move tower shot. reset shot sound. cycle through tower list. draw canon bal. check canon bal enemy colision. play "enemy hit" sound. set enemy poisened, burning 
	 * or frozen. subtract enemy health. deal splash tower damage. flag tower shot for removal. destroy all enemy and award gold if level fifty six (boss level). remove 
	 * shot that went off scren. */
	public void movetowershot() {
		towerShotListLi = towerShotList.listIterator();
		while (towerShotListLi.hasNext()){
			towerShot tsClass = towerShotListLi.next();
			if (tsClass.fireSound.getLongFramePosition() == tsClass.fireSound.getFrameLength()){
				tsClass.fireSound.setFramePosition(0);
			}
			if (tsClass.hitSound.getLongFramePosition() == tsClass.hitSound.getFrameLength()){
				tsClass.hitSound.setFramePosition(0);
			}
			if (tsClass.whichShot == 2 && tsClass.poisenedSound.getLongFramePosition() == 
					tsClass.poisenedSound.getFrameLength()){
				tsClass.poisenedSound.setFramePosition(0);
			}
			if (!paused){
			if (tsClass.quadrent == 0){
				tsClass.rec.x -= tsClass.shotSpeed;
				tsClass.rec.y -= tsClass.slope * tsClass.shotSpeed;
			}
			if (tsClass.quadrent == 1){
				tsClass.rec.x -= tsClass.slope * tsClass.shotSpeed;
				tsClass.rec.y -= tsClass.shotSpeed;
			}
			if (tsClass.quadrent == 2){
				tsClass.rec.x += tsClass.slope * tsClass.shotSpeed;
				tsClass.rec.y -= tsClass.shotSpeed;
			}
			if (tsClass.quadrent == 3){
				tsClass.rec.x += tsClass.shotSpeed;
				tsClass.rec.y -= tsClass.slope * tsClass.shotSpeed;
			}
			if (tsClass.quadrent == 4){
				tsClass.rec.x += tsClass.shotSpeed;
				tsClass.rec.y += tsClass.slope * tsClass.shotSpeed;
			}
			if (tsClass.quadrent == 5){
				tsClass.rec.x += tsClass.slope * tsClass.shotSpeed;
				tsClass.rec.y += tsClass.shotSpeed;
			}
			if (tsClass.quadrent == 6){
				tsClass.rec.x -= tsClass.slope * tsClass.shotSpeed;
				tsClass.rec.y += tsClass.shotSpeed;
			}
			if (tsClass.quadrent == 7){
				tsClass.rec.x -= tsClass.shotSpeed;
				tsClass.rec.y += tsClass.slope * tsClass.shotSpeed;
			}
			}
			if (tsClass.whichShot == 0 && new Random().nextInt(25) == 0){
				g2d.drawImage(bIL[12], new AffineTransform(1, 0, 0, 1, tsClass.rec.x,
						tsClass.rec.y), this);
			}
			if (tsClass.whichShot == 1 && new Random().nextInt(25) == 0){
				g2d.drawImage(bIL[5], new AffineTransform(1, 0, 0, 1, tsClass.rec.x,
						tsClass.rec.y), this);
			}
			if (tsClass.whichShot == 2 && new Random().nextInt(25) == 0){
				g2d.drawImage(bIL[3], new AffineTransform(1, 0, 0, 1, tsClass.rec.x,
						tsClass.rec.y), this);
			}
			if (tsClass.whichShot == 3 && tsClass.isExploding != true && new Random().nextInt(25) == 0){
				g2d.drawImage(bIL[1], new AffineTransform(1, 0, 0, 1, tsClass.rec.x, 
						tsClass.rec.y), this);
			}
			if (tsClass.whichShot == 4 && new Random().nextInt(25) == 0){
				g2d.drawImage(bIL[21], new AffineTransform(1, 0, 0, 1, tsClass.rec.x, 
						tsClass.rec.y), this);
			}
			li = enemyList.listIterator();
			while (li.hasNext()){
				enemys rec11 = li.next();
				if (rec11.rec.intersects(tsClass.rec) && rec11.health > 0){
					if (sound && new Random().nextInt(25) == 0){
					tsClass.hitSound.start();
					}
					rec11.speedMinusFn = roundingMethod(rec11.speed - rec11.frostNumber);
					if (tsClass.whichShot == 1 && rec11.speedMinusFn > .1){
						needsTsRemoved = true;
						rec11.frostNumber += .1;
						if (rec11.isFrozen != true){
							rec11.isFrozen = true;
						}
					}
					if (tsClass.whichShot == 2 && rec11.enemyNumber != 1){
						if (rec11.isPoisened != true){
							if (sound && new Random().nextInt(25) == 0){
							tsClass.poisenedSound.start();
							}
							rec11.isPoisened = true;
							if (rec11.isBurning != true){
								rec11.t.start();
								rec11.t.setDelay(960);
							}
						}
						else{
							rec11.health--;
						}
					}
					if (tsClass.whichShot == 3){
						tsClass.splashRec = new Rectangle2D.Double(tsClass.rec.x + 
								bIL[1].getWidth() / 2 - bIL[28].getWidth() / 2, 
								tsClass.rec.y + bIL[1].getHeight() / 2 - bIL[28].getHeight() / 2,
								bIL[28].getWidth(), bIL[28].getHeight());
						tsClass.isExploding = true;
						tsClass.quadrent = -1;
						tsClass.slope = 0.0;
						tsClass.rec.width = 0;
						tsClass.rec.height = 0;
						tsClass.t.start();
						li = enemyList.listIterator();
						while (li.hasNext()){
							enemys nextEnemy = li.next();
							if (nextEnemy.rec.intersects(tsClass.splashRec) && 
									nextEnemy.health > 0){
								if (nextEnemy.enemyNumber == 1){
								nextEnemy.health -= 26;
								}
								else{
								nextEnemy.health--;
								}
								if (nextEnemy.isBurning != true){
									nextEnemy.isBurning = true;
									if (nextEnemy.isPoisened != true){
										nextEnemy.t.start();
										nextEnemy.t.setDelay(960);
									}
								}
								else{
								nextEnemy.health--;
								}
							}
						}
					}
					if (tsClass.whichShot != 1 && tsClass.whichShot	!= 3){
							if (rec11.enemyNumber != 1 || tsClass.whichShot != 2){
								rec11.health--;
							}
					}
					if (rec11.enemyNumber == 4){
						if (tsClass.whichShot == 2){
							rec11.health -= 28;
						}
						if (tsClass.whichShot == 3){
							rec11.health -= 28;
							}
					}
					if (rec11.enemyNumber != 1 && tsClass.whichShot == 2 && tsClass.whichShot
							!= 3 && tsClass.whichShot != 1 || rec11.enemyNumber == 1
							&& tsClass.whichShot != 2 && tsClass.whichShot != 3
							&& tsClass.whichShot != 1 || rec11.enemyNumber != 1
							&& tsClass.whichShot != 3 && tsClass.whichShot != 1){
					needsTsRemoved = true;
					}
				}
				if (level == 56 && rec11.enemyNumber != 4 && rec11.isDying != true ||
						rec11.health < 1 && rec11.isDying != true){
					if (rec11.t.isRunning()){
						rec11.t.stop();
					}
					if (rec11.enemyNumber != 4){
					rec11.t2.start();
					}
					if (rec11.enemyNumber == 2){
						rec11.aff2.setTransform(rec11.aff);
					}
					if (rec11.enemyNumber != 1 && sound){
					rec11.dying.start();
					}
					if (rec11.enemyNumber == 1 && sound){
					rec11.attacking.start();
					}
					rec11.isDying = true;
					gold += rec11.goldAward;
				}
			}
			if (tsClass.rec.x <= -tsClass.rec.width || tsClass.rec.x >= j.getWidth()
					|| tsClass.rec.y <= -tsClass.rec.height || tsClass.rec.y >= j.getHeight()
					+ tsClass.rec.height || needsTsRemoved || tsClass.needsRemoved){
				towerShotListLi.remove();
				needsTsRemoved = false;
			}
		}
	}
	/** handle the tower information. if player hover over a tower, draw that tower information. display hand pointer on hover. play hover sound. */
	public void handletowerinformation() {
		// draw basic tower information image on hover.
	if (recArray[0].intersects(mouseLocationRectangle)){
		g2d.drawImage(bIL[16], new AffineTransform(1, 0, 0, 1, recArray[0].x + 
				(recArray[0].width - bIL[16].getWidth()) / 2, 13), this);
		if (clickedTower != true){
			j.setCursor(new Cursor(Cursor.HAND_CURSOR));
		if (hasPlayedHoverSound != true && sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[4]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			hasPlayedHoverSound = true;
		}
		g2d.drawImage(bIL[22], new AffineTransform(1, 0, 0, 1, recArray[0].x, 
				recArray[0].y + recArray[0].height + 10), this);
		g2d.drawString(towerCost.toString(), (int)recArray[0].x + 42, 
				(int)recArray[0].y + (int)recArray[0].height + 49);
		}
	}
	// speed tower hover sound
	if (recArray[1].intersects(mouseLocationRectangle)){
		g2d.drawImage(bIL[19], new AffineTransform(1, 0, 0, 1, recArray[1].x + 
				(recArray[1].width - bIL[19].getWidth()) / 2, 13), this);
		if (speedTowerClicked != true){
			j.setCursor(new Cursor(Cursor.HAND_CURSOR));
			if (hasPlayedHoverSound != true && sound){
				try {
					hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[4]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				hasPlayedHoverSound = true;
			}
			g2d.drawImage(bIL[25], new AffineTransform(1, 0, 0, 1, recArray[1].x, 
					recArray[1].y + recArray[1].height + 10), this);
			g2d.drawString(frostTowerCost.toString(), (int)recArray[1].x + 50, 
					(int)recArray[1].y + (int)recArray[1].height + 50);
		}
	}
	// poisen tower information
	if (recArray[2].intersects(mouseLocationRectangle)){
		g2d.drawImage(bIL[17], new AffineTransform(1, 0, 0, 1, recArray[2].x + 
				(recArray[2].width - bIL[17].getWidth()) / 2, 13), this);
		if (poisenClicked != true){
			j.setCursor(new Cursor(Cursor.HAND_CURSOR));
			if (hasPlayedHoverSound != true && sound){
				try {
					hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[4]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				hasPlayedHoverSound = true;
			}
			g2d.drawImage(bIL[23], new AffineTransform(1, 0, 0, 1, recArray[2].x, 
					recArray[2].y + recArray[2].height + 10), this);
			g2d.drawString(speedTowerCost.toString(), (int)recArray[2].x + 42, 
					(int)recArray[2].y + (int)recArray[2].height + 49);
		}
	}
	// frost tower information
	if (recArray[3].intersects(mouseLocationRectangle)){
		g2d.drawImage(bIL[18], new AffineTransform(1, 0, 0, 1, recArray[3].x + 
				(recArray[3].width - bIL[18].getWidth()) / 2, 13), this);
		if (fTClicked != true){
			j.setCursor(new Cursor(Cursor.HAND_CURSOR));
			if (hasPlayedHoverSound != true && sound){
				try {
					hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[4]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				hasPlayedHoverSound = true;
			}
			g2d.drawImage(bIL[24], new AffineTransform(1, 0, 0, 1, recArray[3].x, 
					recArray[3].y + recArray[3].height + 10), this);
			g2d.drawString(poisenTowerCost.toString(), (int)recArray[3].x + 50, 
					(int)recArray[3].y + (int)recArray[3].height + 50);
		}
	}
	// splash tower information
	if (recArray[4].intersects(mouseLocationRectangle)){
		g2d.drawImage(bIL[20], new AffineTransform(1, 0, 0, 1, recArray[4].x + 
				(recArray[4].width - bIL[20].getWidth()) / 2, 17), this);
		if (splashClicked != true){
			j.setCursor(new Cursor(Cursor.HAND_CURSOR));
			if (hasPlayedHoverSound != true && sound){
				try {
					hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[4]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				hasPlayedHoverSound = true;
			}
			g2d.drawImage(bIL[26], new AffineTransform(1, 0, 0, 1, recArray[4].x, 
					recArray[4].y + recArray[4].height + 10), this);
			g2d.drawString(splashTowerCost.toString(), (int)recArray[4].x + 48, 
					(int)recArray[4].y + (int)recArray[4].height + 50);
		}
	}
	}
    public void paintComponent(Graphics g){
		super.paintComponent(g);
		g2d = (Graphics2D) g;
		// reset sound / remove
		hACSoundsLi = hACSounds.listIterator();
		while (hACSoundsLi.hasNext()){
			hoverAndClickSounds hACS = hACSoundsLi.next();
			if (hACS.clip.getLongFramePosition() == hACS.clip.getFrameLength()){
				hACS.clip.setFramePosition(0);
				hACSoundsLi.remove();
			}
		}
 		mouseLocationRectangle.setLocation((int)mouseLocation.getX(), (int)mouseLocation.getY());
 		// game background
		g2d.drawImage(bIL[8], new AffineTransform(), this);
		// video game foreground
		g2d.drawImage(bIL[9], new AffineTransform(1, 0, 0, 1, 714, 423), this);
		g2d.drawImage(bIL[10], new AffineTransform(1, 0, 0, 1, 664, 58), this);
		if (gh > 0){
			// gate
			g2d.drawImage(bIL[14], new AffineTransform(1, 0, 0, 1, 1132, 157), this);
		}
		else{
			if (sound){
				// gate destroyed sound
				clickingPlayButtonArray[24].start();
			}
			// gate breaking animation
			iIL[26].paintIcon(this, g2d, 1132, 157);
		}
		handleenemyanimation();
		// splash tower animation
		towerShotListLi = towerShotList.listIterator();
		while (towerShotListLi.hasNext()){
			towerShot nextTowerShot = towerShotListLi.next();
			if (nextTowerShot.isExploding && nextTowerShot.whichFrame <= 31 && new Random().nextInt(25) == 0){
				 g2d.drawImage(bIL[nextTowerShot.whichFrame], 
						new AffineTransform(1, 0, 0, 1, nextTowerShot.rec.x + bIL[1].getWidth()
						/ 2 - bIL[28].getWidth() / 2, nextTowerShot.rec.y + 
						bIL[1].getHeight() / 2 - bIL[28].getHeight() / 2), this);
			}
		}
		// display enemy health
		li = enemyList.listIterator();
		while (li.hasNext()){
			enemys nextE = li.next();
			if (nextE.isDying != true){
			g2d.setColor(new Color(100, 100, 100, 100));
			g2d.fill(new Rectangle2D.Double(nextE.aff.getTranslateX() - 1, 
					nextE.aff.getTranslateY() - 26, 63, 13));
			g2d.setColor(Color.BLACK);
			if (nextE.explodedOnGate != true){
			g2d.drawString("Hp: " + nextE.health.toString(), 
					(int)nextE.aff.getTranslateX(), 
					(int)nextE.aff.getTranslateY() - 15);
				}
			}
		}
		g2d.drawImage(bIL[13], new AffineTransform(1, 0, 0, 1, 515, 385), this);
		
		// draw player tower
		slLi = structureList.listIterator();
		while (slLi.hasNext()){
			structure structureAff = slLi.next();
			if (structureAff.onesAndZeros.equals(0) && paused){
				structureAff.t.stop();
				if (structureAff.hasFired){
					structureAff.time2 = structureAff.t.getDelay() - 
							((int) System.currentTimeMillis() - structureAff.time);
				}
				else{
					structureAff.time2 -= (int) System.currentTimeMillis()
							- structureAff.placeHolder2;
				}
				if (structureAff.hasFired){
					structureAff.hasFired = false;
				}
				structureAff.onesAndZeros = -1;
			}
			if (structureAff.onesAndZeros.equals(1) && !paused){
				//System.out.println(time2);
				if (structureAff.time2 < 0){
					structureAff.time2 = 0;
				}
				structureAff.t.setInitialDelay(structureAff.time2);
				structureAff.t.start();
				structureAff.placeHolder2 = (int) System.currentTimeMillis();
				structureAff.onesAndZeros = 0;
			}
			if (structureAff.onesAndZeros.equals(-1)){
				structureAff.onesAndZeros = 1;
			}
			if (structureAff.whichStructure == "tower"){
				g2d.drawImage(bIL[11], structureAff.aff2, this);
			}
			if (structureAff.whichStructure == "speedTower"){
				g2d.drawImage(bIL[17], structureAff.aff2, this);
			}
			if (structureAff.whichStructure == "frostTower"){
				g2d.drawImage(bIL[4], structureAff.aff2, this);
			}
			if (structureAff.whichStructure == "poisenTower"){
				g2d.drawImage(bIL[2], structureAff.aff2, this);
			}
			if (structureAff.whichStructure == "splashTower"){
				g2d.drawImage(bIL[0], structureAff.aff2, this);
			}
		}
		movetowershot();
		// "gold:" image
		g2d.drawImage(bIL[27], new AffineTransform(1, 0, 0, 1, 10, 10), this);
		fontAndColor(24, Color.BLACK);
		// display curent player gold
		g2d.drawString(gold.toString(), 83, 43);
		fontAndColor(16, g2d.getColor());
		// display gate health at the top left
		g2d.drawString(gh.toString(), 104, 59);
		// display level
		g2d.drawString("Level: " + level, 24, 75);
		// draw player tower. splash, basic, speed, poisen and frost.
		g2d.drawImage(bIL[11], new AffineTransform(1, 0, 0, 1, recArray[0].x + (recArray[0].width
				- bIL[11].getWidth()) / 2, 13), this);
		g2d.drawImage(bIL[4], new AffineTransform(1, 0, 0, 1, recArray[1].x + (recArray[1].width
				- bIL[4].getWidth()) / 2, 13), this);
		g2d.drawImage(bIL[15], new AffineTransform(1, 0, 0, 1, recArray[2].x + (recArray[2].width
				- bIL[15].getWidth()) / 2, 13), this);
		g2d.drawImage(bIL[2], new AffineTransform(1, 0, 0, 1, recArray[3].x + (recArray[3].width
				- bIL[2].getWidth()) / 2, 13), this);
		g2d.drawImage(bIL[0], new AffineTransform(1, 0, 0, 1, recArray[4].x + (recArray[4].width
				- bIL[0].getWidth()) / 2, 17), this);
		// if the game has started from title scren
		if (playing){
			handletowerinformation();
	}
		if (displayingLevel){
			fontAndColor(64, Color.BLACK);
			if (level == 56){
				g2d.drawString("Boss Level", j.getWidth() / 2, j.getHeight() / 2);
			}
			else{
				// display if the next level ocur
				g2d.drawString("Level: " + level, j.getWidth() / 2, j.getHeight() / 2);
			}
		}
		//player kil boss
			if (playing && bossIsDead && gh > 0){
				fontAndColor(64, Color.BLACK);
				g2d.drawString("You Win!", 150, 190);
				g2d.drawImage(bIL[51], creditsButtonLocation, this);
				if (mouseLocationRectangle.intersects(creditsButtonRectangle)){
					j.setCursor(new Cursor(Cursor.HAND_CURSOR));
					if (hasPlayedHoverSound != true && sound){
						try {
							hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[1]));
						} catch (UnsupportedAudioFileException | IOException
								| LineUnavailableException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						hasPlayedHoverSound = true;
					}
					g2d.drawImage(bIL[52], creditsButtonLocation, this);
				}
			}
			// video game started. "play" and "instruction" image displayed
		if (titleScreenBoolean){
			//game menu background
			g2d.drawImage(bIL[48], new AffineTransform(), this);
			g2d.drawImage(bIL[49], playLocation, this);
			if (mouseLocationRectangle.intersects(playButtonRectangle)){
				j.setCursor(new Cursor(Cursor.HAND_CURSOR));
				if (hasPlayedHoverSound != true && sound){
				try {
					hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[1]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				hasPlayedHoverSound = true;
				}
				// highlight "play"
				g2d.drawImage(bIL[50], playLocation, this);
			}
			g2d.drawImage(bIL[53], new AffineTransform(1, 0, 0, 1, playLocation.getTranslateX(), 
					playLocation.getTranslateY() + bIL[49].getHeight() + 25), this);
			if (mouseLocationRectangle.intersects(instructionsButtonRectangle)){
				j.setCursor(new Cursor(Cursor.HAND_CURSOR));
				if (hasPlayedHoverSound != true && sound){
				try {
					hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[1]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				hasPlayedHoverSound = true;
				}
				g2d.drawImage(bIL[54], new AffineTransform(1, 0, 0, 1,
						playLocation.getTranslateX(), playLocation.getTranslateY() + 
						bIL[49].getHeight() + 25), this);
			}
		}
		// display instruction image
		if (instructionsScreenBoolean){
			g2d.drawImage(bIL[55], new AffineTransform(), this);
			g2d.drawImage(bIL[56], backButtonLocation, this);
			if (mouseLocationRectangle.intersects(backButtonRectangle)){
				j.setCursor(new Cursor(Cursor.HAND_CURSOR));
				if (hasPlayedHoverSound != true && sound){
					try {
						hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[1]));
					} catch (UnsupportedAudioFileException | IOException
							| LineUnavailableException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					hasPlayedHoverSound = true;
				}
				g2d.drawImage(bIL[57], backButtonLocation, this);
			}
		}
		// enemy distroyed player gate, game over.
		if (gh <= 0){
			fontAndColor(g2d.getFont().getSize(), new Color(100, 100, 100, 185));
			g2d.fillRect(0, 180, j.getWidth(), 68);
			fontAndColor(64, Color.BLACK);
			g2d.drawString("The enemys have broken through the gate", 75, 230);
			g2d.drawImage(bIL[60], new AffineTransform(1, 0, 0, 1, 75, 290), this);
			if (mouseLocationRectangle.intersects(retryButtonRectangle)){
				j.setCursor(new Cursor(Cursor.HAND_CURSOR));
				if (hasPlayedHoverSound != true && sound){
				try {
					hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[1]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				hasPlayedHoverSound = true;
				}
				g2d.drawImage(bIL[61], new AffineTransform(1, 0, 0, 1, 75, 290), this);
			}
		}
		// player is victorious and watching the credit scren
		if (watchingCredits){
			g2d.drawImage(bIL[58], new AffineTransform(), this);
			if (authorLocation.getTranslateY() + bIL[59].getHeight() >= 0){
			g2d.drawImage(bIL[59], authorLocation, this);
			authorLocation.translate(0, -.5);
			}
		}
		//System.out.println(hasPlayedHoverSound);
		// posible hover sound bug
		if (mouseLocationRectangle.intersects(backButtonRectangle) != true && 
				mouseLocationRectangle.intersects(creditsButtonRectangle) != true && 
				mouseLocationRectangle.intersects(instructionsButtonRectangle) != true && 
				mouseLocationRectangle.intersects(mouseLocationRectangle) != true && 
				mouseLocationRectangle.intersects(musicRectangle) != true && 
				mouseLocationRectangle.intersects(pauseRectangle) != true && 
				mouseLocationRectangle.intersects(pausedRectangle) != true && 
				mouseLocationRectangle.intersects(playButtonRectangle) != true && 
				mouseLocationRectangle.intersects(retryButtonRectangle) != true && 
				mouseLocationRectangle.intersects(soundRectangle) != true && hasPlayedHoverSound){
			hasPlayedHoverSound = false;
		}
		//System.out.println(hasPlayedHoverSound);
		if (mouseLocationRectangle.intersects(playButtonRectangle) != true && 
				mouseLocationRectangle.intersects(instructionsButtonRectangle) != true && 
				mouseLocationRectangle.intersects(soundRectangle) != true && 
				mouseLocationRectangle.intersects(musicRectangle) != true && titleScreenBoolean){
			j.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
		if (mouseLocationRectangle.intersects(backButtonRectangle) != true && 
				mouseLocationRectangle.intersects(soundRectangle) != true && 
				mouseLocationRectangle.intersects(musicRectangle) != true &&
				instructionsScreenBoolean){
			j.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
		if (recArray[0].intersects(mouseLocationRectangle) != true 
				&& recArray[1].intersects(mouseLocationRectangle) != true 
				&& recArray[2].intersects(mouseLocationRectangle) != true && 
				recArray[3].intersects(mouseLocationRectangle) != true && 
				recArray[4].intersects(mouseLocationRectangle) != true && 
				mouseLocationRectangle.intersects(soundRectangle) != true && 
				mouseLocationRectangle.intersects(musicRectangle) != true && 
				mouseLocationRectangle.intersects(pauseRectangle) != true && playing && 
				mouseLocationRectangle.intersects(pausedRectangle) != true){
			j.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
		if (mouseLocationRectangle.intersects(retryButtonRectangle) != true && gh < 1 && playing){
			j.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
		if (mouseLocationRectangle.intersects(creditsButtonRectangle) && bossHealth < 1
				&& playing){
			j.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
		// set pause / resume image
		if (playing){
			if (paused){
				g2d.drawImage(bIL[67], pauseButtonLocation, this);
				if (mouseLocationRectangle.intersects(pausedRectangle)){
					g2d.drawImage(bIL[69], pauseButtonLocation, this);
				}
			}
			else{
		g2d.drawImage(bIL[66], pauseButtonLocation, this);
			if (mouseLocationRectangle.intersects(pauseRectangle)){
				g2d.drawImage(bIL[68], pauseButtonLocation, this);
			}
			}
		}
		g2d.drawImage(bIL[62], new AffineTransform(1, 0, 0, 1, soundRectangle.x, 
				soundRectangle.y), this);
		if (mouseLocationRectangle.intersects(soundRectangle)){
			j.setCursor(new Cursor(Cursor.HAND_CURSOR));
			if (sound){
			g2d.drawImage(bIL[70], new AffineTransform(1, 0, 0, 1, soundRectangle.x,
					soundRectangle.y), this);
			}
		}
		if (sound != true){
			g2d.drawImage(bIL[64], new AffineTransform(1, 0, 0, 1, soundRectangle.x, 
					soundRectangle.y), this);
		}
		g2d.drawImage(bIL[63], new AffineTransform(1, 0, 0, 1, musicRectangle.x, 
				musicRectangle.y), this);
		if (mouseLocationRectangle.intersects(musicRectangle)){
			j.setCursor(new Cursor(Cursor.HAND_CURSOR));
			if (music){
			g2d.drawImage(bIL[71], new AffineTransform(1, 0, 0, 1, musicRectangle.x, 
					musicRectangle.y), this);
			}
		}
		if (music != true){
			g2d.drawImage(bIL[65], new AffineTransform(1, 0, 0, 1, musicRectangle.x, 
					musicRectangle.y), this);
		}
		// display basic tower at user mouse point if clicked
	if (clickedTower){
		g2d.drawImage(bIL[11], new AffineTransform(1, 0, 0, 1, mouseLocation.x, 
				mouseLocation.y), this);
	}
	if (fTClicked){
		g2d.drawImage(bIL[4], new AffineTransform(1, 0, 0, 1, mouseLocation.x, 
				mouseLocation.y), this);
	}
	if (speedTowerClicked){
		g2d.drawImage(bIL[17], new AffineTransform(1, 0, 0, 1, mouseLocation.x, 
				mouseLocation.y), this);
	}
	if (poisenClicked){
		g2d.drawImage(bIL[2], new AffineTransform(1, 0, 0, 1, mouseLocation.x, 
				mouseLocation.y), this);
	}
	if (splashClicked){
		g2d.drawImage(bIL[0], new AffineTransform(1, 0, 0, 1, mouseLocation.x, 
				mouseLocation.y), this);
	}
		repaint();
	}
    /** add enemy periodicly. increase, sebtract or set enemy health (gameplay). */
	@SuppressWarnings("deprecation")
	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == t){
			t1HasFired = true;
			forTimers[1] = (int) System.currentTimeMillis();
			if (t2.isRunning() != true){
				t2HasStarted = true;
				displayingLevel = true;
				forTimers[4] = (int) System.currentTimeMillis();
				t2HasFired = true;
				t2.start();
				forTimers[7] = (int) System.currentTimeMillis();
				t3HasFired = true;
				t3.start();
			}
			rand = new Integer(new Random().nextInt(184));
			try {
				enemyList.add(new enemys(new AffineTransform(1, 0, 0, 1, 
						-iIL[1].getIconWidth(), 161 +
						rand), 0, 10, peasentHealth, speed, iIL[1], iIL[2], iIL[3], iIL[4], 
						iIL[5], iIL[6]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			if (level > 5){
			rand = new Integer(new Random().nextInt(184));
			try {
				enemyList.add(new enemys(new AffineTransform(1, 0, 0, 1, 
						-iIL[7].getIconWidth(), 161 + rand), 1, 20, walkingBombHealth, speed,
						iIL[7], iIL[8], iIL[8], iIL[7], iIL[7], iIL[7]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			}
			if (level > 11){
				rand = new Integer(new Random().nextInt(184));
				try {
					enemyList.add(new enemys(new AffineTransform(1, 0, 0, 1, 
							-iIL[9].getIconWidth(), 161 + rand), 2, 30, knightHealth, speed,
							iIL[9], iIL[10], iIL[12], iIL[13], iIL[14], iIL[15]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
			if (level > 17){
				rand = new Integer(new Random().nextInt(184));
				try {
					enemyList.add(new enemys(new AffineTransform(1, 0, 0, 1, 
							-iIL[16].getIconWidth(), 161 + rand), 3, 40, doorSmasherHealth,
							speed, iIL[16], iIL[19], iIL[18], iIL[20], iIL[21], iIL[22]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
			if (level == 56){
				t.stop();
				t2.stop();
				li = enemyList.listIterator();
				while (li.hasNext()){
					enemys nextEn = li.next();
					if (nextEn.health > 0){
					nextEn.health = 0;
					if (nextEn.enemyNumber != 1){
					nextEn.dying.start();
					}
					else{
					nextEn.attacking.start();
					}
					nextEn.isDying = true;
					}
				}
				rand = new Integer(new Random().nextInt(144));
				try {
					enemyList.add(new enemys(new AffineTransform(1, 0, 0, 1, 
							-iIL[23].getIconWidth(), 181 + rand), 4, 0, bossHealth, speed,
							iIL[23], iIL[25], iIL[24], iIL[23], iIL[23], iIL[23]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		}
		// gameplay
		if (e.getSource() == t2){
			forTimers[4] = (int) System.currentTimeMillis();
			t2HasFired = true;
			// as long as the timer is not firing too quick, fire the timer faster (enemy spawn timer).
			if (t.getDelay() - 600 >= 5600){
				t.setDelay(t.getDelay() - 600);
			}
			speed = roundingMethod(speed);
			if (level > 31 && speed < 1 && new Random().nextInt(2) == 0){
				speed += .1;
			}
			if (level == 7){
				healthAddition += 12;
			}
			if (level == 11){
				healthAddition -= 14;
			}
			if (level == 15){
				healthAddition += 5;
			}
			if (level >= 18 && level <= 20){
				healthAddition += 9;
			}
			if (level == 24){
				healthAddition = 34;
			}
			if (level == 32){
				healthAddition += 6;
			}
			if (level == 42){
				healthAddition = 30;
			}
			if (level != 1){
				peasentHealth += healthAddition;
				if (level >= 7){
				walkingBombHealth += healthAddition;
				}
				if (level >= 9){
				knightHealth += healthAddition;
				}
				if (level >= 19){
				doorSmasherHealth += healthAddition;
				}
			}
			// increase level if timer two go off
			level++;
			displayingLevel = true;
			forTimers[7] = (int) System.currentTimeMillis();
			t3HasFired = true;
			t3.start();
		}
		if (e.getSource() == t3){
			displayingLevel = false;
			t3.stop();
			if (t3.getInitialDelay() != 4000){
			t3.setInitialDelay(4000);
			}
		}
	}
	
	/** calculate slope from point a to point b. tower shot to enemy. add shot. 
	 * @see #movetowershot */
    @SuppressWarnings("deprecation")
	public void structureShot(Point2D.Double p1, Point2D.Double p2, BufferedImage b2, 
    		Integer whichShot2) throws UnsupportedAudioFileException, IOException,
    		LineUnavailableException{
    		if (p1.x >= p2.x && p1.y >= p2.y && p1.x - p2.x >= p1.y - p2.y){
    			slope2 = new Double((double)(p1.y - p2.y) / (p1.x - p2.x));
    			quad2 = new Integer(0);
    		}
    		if (p1.x >= p2.x && p1.y >= p2.y && p1.y - p2.y > p1.x - p2.x){
    			slope2 = new Double((double)(p1.x - p2.x) / (p1.y - p2.y));
    			quad2 = new Integer(1);
    		}
    		if (p2.x >= p1.x && p1.y >= p2.y && p1.y - p2.y >= p2.x - p1.x){
    			slope2 = new Double((double)(p2.x - p1.x) / (p1.y - p2.y));
    			quad2 = new Integer(2);
    		}
    		if (p2.x >= p1.x && p1.y >= p2.y && p2.x - p1.x > p1.y - p2.y){
    			slope2 = new Double((double)(p1.y - p2.y) / (p2.x - p1.x));
    			quad2 = new Integer(3);
    		}
    		if (p2.x >= p1.x && p2.y >= p1.y && p2.x - p1.x >= p2.y - p1.y){
    			slope2 = new Double((double)(p2.y - p1.y) / (p2.x - p1.x));
    			quad2 = new Integer(4);
    		}
    		if (p2.x >= p1.x && p2.y >= p1.y && p2.y - p1.y > p2.x - p1.x){
    			slope2 = new Double((double)(p2.x - p1.x) / (p2.y - p1.y));
    			quad2 = new Integer(5);
    		}
    		if (p1.x >= p2.x && p2.y >= p1.y && p2.y - p1.y >= p1.x - p2.x){
    			slope2 = new Double((double)(p1.x - p2.x) / (p2.y - p1.y));
    			quad2 = new Integer(6);
    		}
    		if (p1.x >= p2.x && p2.y >= p1.y && p1.x - p2.x > p2.y - p1.y){
    			slope2 = new Double((double)(p2.y - p1.y) / (p1.x - p2.x));
    			quad2 = new Integer(7);
    		}
    		towerShotList.add(new towerShot(new Rectangle2D.Double(p1.x, p1.y, b2.getWidth(), 
    				b2.getHeight()), slope2, quad2, whichShot2));
    }
    /** return araylist. sort enemy list from right to left. take enemy list as argument. the tower wil shoot at the first enemy closest to gate after this method is 
     * caled. otherwise the tower shoot at enemy on the left. help protect gate. arange number from greatest to least, x axis (coordinate). add the enemy image (animation)
     * to the x coordinate. compare first araylist value to all other, if smalest put in front. count represent curent value while cycling through list. */
	public ArrayList<enemys> arrangeNumbers(ArrayList<enemys> list){
		@SuppressWarnings("deprecation")
		Integer count = new Integer(0);
		@SuppressWarnings("deprecation")
		Integer count2 = new Integer(1);
		while (list.size() > 1 && count != list.size() - 1){
			if (list.get(count2).aff.getTranslateX() + list.get(count2).enemyImage.getIconWidth()
					> list.get(count).aff.getTranslateX() + 
					list.get(count).enemyImage.getIconWidth()){
				list.add(count, list.get(count2));
				list.remove(count2 + 1);
			}
			if (count2 == list.size() - 1){
				count++;
				count2 = count + 1;
			}
			else{
			count2++;
			}
		}
		return list;
	}
	/** round number to ten 
	 * @param d
	 * @return double roundednumber */
	public Double roundingMethod(Double d){
		rounder = new BigDecimal(d);
		return roundedNumber = rounder.round(mc).doubleValue();
	}
	public void fontAndColor(Integer i, Color c){
		g2d.setFont(new Font("Times New Roman", 0, i));
		g2d.setColor(c);
	}
	/** known bug */
	public void setUpForRetry(){
		li = enemyList.listIterator();
		while (li.hasNext()){
			li.next();
			li.remove();
		}
		enemyList.clear();
		slLi = structureList.listIterator();
		while (slLi.hasNext()){
			structure st = slLi.next();
			st.t.stop();
			slLi.remove();
		}
		structureList.clear();
		towerShotListLi = towerShotList.listIterator();
		while (towerShotListLi.hasNext()){
			towerShotListLi.next();
			towerShotListLi.remove();
		}
		towerShotList.clear();
		level = 1;
		gold = 50;
		gh = 750000;
		if (bossIsDead || bossHealth != 38490){
			bossHealth = 38490;
			bossIsDead = false;
		}
		peasentHealth = 30;
		walkingBombHealth = 40;
		knightHealth = 72;
		doorSmasherHealth = 106;
		healthAddition = 2;
		speed = .1;
		t.setDelay(24000);
		t.restart();
		t2.stop();
		t3.stop();
	}
	@Override
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void mouseMoved(MouseEvent e) {
		mouseLocation = e.getPoint();
		mouseLocation.translate(-8, -31);
    	mouseLocationRectangle.setLocation(mouseLocation.x, mouseLocation.y);
	}
	public void mousePressed(MouseEvent e) {
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    /** handle game mouse click. "start", basic tower, drop tower on ledge excetera. */
    public void mouseClicked(MouseEvent e) {
    	if (titleScreenBoolean){
    	if (mouseLocationRectangle.intersects(playButtonRectangle)){
    		if (sound){
    		try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[0]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
    		}
    		clickingPlayButtonArray[25].stop();
    		if (music){
    		clickingPlayButtonArray[26].loop(Clip.LOOP_CONTINUOUSLY);
    		}
    		forTimers[1] = (int) System.currentTimeMillis();
    		t.start();
    		titleScreenBoolean = false;
    		playing = true;
    	}
    	if (mouseLocationRectangle.intersects(instructionsButtonRectangle)){
    		if (sound){
    		try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[2]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
    		}
    		titleScreenBoolean = false;
    		instructionsScreenBoolean = true;
    	}
    	}
    	if (mouseLocationRectangle.intersects(backButtonRectangle) && instructionsScreenBoolean){
    		if (sound){
    		try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[2]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
    		}
    		instructionsScreenBoolean = false;
    		titleScreenBoolean = true;
    	}
    	if (mouseLocationRectangle.intersects(retryButtonRectangle) && playing && gh < 1){
    		if(sound){
    		try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[2]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
    		}
    		setUpForRetry();
    	}
		if (mouseLocationRectangle.intersects(creditsButtonRectangle) && playing && bossIsDead){
			if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[2]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			}
			clickingPlayButtonArray[26].stop();
			if (music){
				clickingPlayButtonArray[27].loop(Clip.LOOP_CONTINUOUSLY);
			}
			playing = false;
			watchingCredits = true;
		}
    	if (mouseLocationRectangle.intersects(buildAreaOne) || 
    			mouseLocationRectangle.intersects(buildAreaTwo)){
			if (clickedTower){
				if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[5]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				}
			structureList.add(new structure(new AffineTransform(1, 0, 0, 1, 
					mouseLocationRectangle.x, mouseLocationRectangle.y), "tower", bIL[11], 
					bIL[12]));
			gold -= towerCost;
			clickedTower = false;
			}
			if (speedTowerClicked){
				if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[5]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				}
			structureList.add(new structure(new AffineTransform(1, 0, 0, 1, 
					mouseLocationRectangle.x, mouseLocationRectangle.y), "speedTower", bIL[15], 
					bIL[21]));
			gold -= speedTowerCost;
			speedTowerClicked = false;
			}
			if (poisenClicked){
				if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[5]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				}
			structureList.add(new structure(new AffineTransform(1, 0, 0, 1, 
					mouseLocationRectangle.x, mouseLocationRectangle.y), "poisenTower", bIL[4], 
					bIL[5]));
			gold -= poisenTowerCost;
			poisenClicked = false;
			}
			if (fTClicked){
				if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[5]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				}
			structureList.add(new structure(new AffineTransform(1, 0, 0, 1, 
					mouseLocationRectangle.x, mouseLocationRectangle.y), "frostTower", bIL[2], 
					bIL[3]));
			gold -= frostTowerCost;
			fTClicked = false;
			}
			if (splashClicked){
				if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[5]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				}
			structureList.add(new structure(new AffineTransform(1, 0, 0, 1, 
					mouseLocationRectangle.x, mouseLocationRectangle.y), "splashTower", bIL[0], 
					bIL[1]));
			gold -= splashTowerCost;
			splashClicked = false;
			}
		}
    	if (playing){
		if (mouseLocationRectangle.intersects(recArray[0]) && gold >= towerCost){
			if (clickedTower){
				clickedTower = false;
				skipIt = true;
			}
			if (speedTowerClicked || poisenClicked || fTClicked || splashClicked || 
					clickedTower != true && skipIt != true){
				if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[3]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				}
			splashClicked = false;
			fTClicked = false;
			poisenClicked = false;
			speedTowerClicked = false;
			clickedTower = true;
			}
			skipIt = false;
		}
		if (mouseLocationRectangle.intersects(recArray[1]) && gold >= frostTowerCost){
			if (fTClicked){
				fTClicked = false;
				skipIt = true;
			}
			if (speedTowerClicked || poisenClicked || clickedTower || splashClicked || 
					fTClicked != true && skipIt != true){
				if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[3]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				}
			splashClicked = false;
			poisenClicked = false;
			clickedTower = false;
			speedTowerClicked = false;
			fTClicked = true;
			}
			skipIt = false;
		}
		if (mouseLocationRectangle.intersects(recArray[2]) && gold >= speedTowerCost){
			if (speedTowerClicked){
				speedTowerClicked = false;
				skipIt = true;
			}
			if (poisenClicked || fTClicked || clickedTower || splashClicked || 
					speedTowerClicked != true && skipIt != true){
				if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[3]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				}
			splashClicked = false;
			fTClicked = false;
			clickedTower = false;
			poisenClicked = false;
			speedTowerClicked = true;
			}
			skipIt = false;
		}
		if (mouseLocationRectangle.intersects(recArray[3]) && gold >= poisenTowerCost){
			if (poisenClicked){
				poisenClicked = false;
				skipIt = true;
			}
			if (speedTowerClicked || fTClicked || clickedTower || poisenClicked || 
					poisenClicked != true && skipIt != true){
				if (sound){
			try {
				hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[3]));
			} catch (UnsupportedAudioFileException | IOException
					| LineUnavailableException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				}
			splashClicked = false;
			fTClicked = false;
			clickedTower = false;
			speedTowerClicked = false;
			poisenClicked = true;
			}
			skipIt = false;
		}
		if (mouseLocationRectangle.intersects(recArray[4]) && gold >= splashTowerCost){
			if (splashClicked){
				splashClicked = false;
				skipIt = true;
			}
			if (speedTowerClicked || fTClicked || clickedTower || poisenClicked || 
					splashClicked != true && skipIt != true){
				if (sound){
				try {
					hACSounds.add(new hoverAndClickSounds(clickingPlayButtonArray[3]));
				} catch (UnsupportedAudioFileException | IOException
						| LineUnavailableException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				}
				clickedTower = false;
				speedTowerClicked = false;
				poisenClicked = false;
				fTClicked = false;
				splashClicked = true;
			}
			skipIt = false;
		}
    	if (mouseLocationRectangle.intersects(pauseRectangle) && !paused || 
    			mouseLocationRectangle.intersects(pausedRectangle) && paused){
    		if (!paused){
    		paused = true;
			if (t1HasFired){
				forTimers[2] = t.getDelay() - ((int) System.currentTimeMillis() - forTimers[1]);
			}
			else{
				forTimers[2] -= (int) System.currentTimeMillis() - forTimers[3];
			}
			if (t1HasFired){
				t1HasFired = false;
			}
			if (t2HasStarted){
			if (t2HasFired){
				forTimers[5] = t2.getDelay() - ((int) System.currentTimeMillis() - forTimers[4]);
			}
			else{
				forTimers[5] -= (int) System.currentTimeMillis() - forTimers[6];
			}
			if (t2HasFired){
				t2HasFired = false;
			}
			}
    		if (displayingLevel){
    			if (t3HasFired){
    				// might need to be improved (code style)
    				forTimers[8] = t3.getDelay() - ((int) System.currentTimeMillis()
    						- forTimers[7]);
    			}
    			else{
    				forTimers[8] -= (int) System.currentTimeMillis() - forTimers[9];
    			}
    			if (t3HasFired){
    				t3HasFired = false;
    			}
    			t3.stop();
    		}
    		t.stop();
    		t2.stop();
    		skipIt = true;
    		}    	
    		if (paused && skipIt != true){
    			if (level != 56){
    			t.setInitialDelay(forTimers[2]);
    			t.start();
    			}
    			forTimers[3] = (int) System.currentTimeMillis();
    			if (t2HasStarted && level != 56){
    			t2.setInitialDelay(forTimers[5]);
    			t2.start();
    			forTimers[6] = (int) System.currentTimeMillis();
    			}
    			if (displayingLevel){
    				t3.setInitialDelay(forTimers[8]);
    				t3.start();
    				forTimers[9] = (int) System.currentTimeMillis();
    			}
        		paused = false;
        	}
        	skipIt = false;
    	}
    	}
		if (mouseLocationRectangle.intersects(soundRectangle)){
			if (sound){
				sound = false;
				skipIt = true;
			}
			if (sound != true && skipIt != true){
				sound = true;
			}
			skipIt = false;
		}
		if (mouseLocationRectangle.intersects(musicRectangle)){
			if (music){
				if (titleScreenBoolean || instructionsScreenBoolean){
					clickingPlayButtonArray[25].stop();
				}
				if (playing){
					clickingPlayButtonArray[26].stop();
				}
				if (watchingCredits){
					clickingPlayButtonArray[27].stop();
				}
				skipIt = true;
				music = false;
			}
			if (music != true && skipIt != true){
				if (titleScreenBoolean || instructionsScreenBoolean){
					clickingPlayButtonArray[25].loop(Clip.LOOP_CONTINUOUSLY);
				}
				if (playing){
					clickingPlayButtonArray[26].loop(Clip.LOOP_CONTINUOUSLY);
				}
				if (watchingCredits){
					clickingPlayButtonArray[27].loop(Clip.LOOP_CONTINUOUSLY);
				}
				music = true;
			}
			skipIt = false;
		}
    }
    
    /** player tower object. fire shot periodicly.
     * @param location
     * @param type
     * @param image
     * @param shotimage */
	class structure implements ActionListener{
		/** where player tower is located */
		AffineTransform aff2;
		/** tower shot rate */
		Timer t;
		Integer poisenCount, onesAndZeros, time, time2, placeHolder2;
		/** true if this tower has fired before fire timer is reset and can fire again */
		Boolean hasFired;
		/** "tower", "sped tower", "poisen tower", "splash tower" and "frost tower" */
		String whichStructure;
		Point2D.Double pointA, pointB;
		BufferedImage tower, shot;
		@SuppressWarnings("deprecation")
		public structure(AffineTransform aff3, String whichStructure2, BufferedImage tower2, 
				BufferedImage shot2){
			tower = tower2;
			shot = shot2;
			poisenCount = new Integer(0);
			time = new Integer((int) System.currentTimeMillis());
			time2 = new Integer(0);
			placeHolder2 = new Integer(0);
			onesAndZeros = new Integer(0);
			hasFired = new Boolean(true);
			pointA = new Point2D.Double();
			pointB = new Point2D.Double();
			whichStructure = whichStructure2;
			aff2 = aff3;
			t = new Timer(0, this);
			t.start();
			t.setDelay(960);
			if (whichStructure == "speedTower"){
				t.setDelay(80);
			}
			if (whichStructure == "frostTower"){
				t.setDelay(1920);
			}
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			time = (int) System.currentTimeMillis();
			hasFired = true;
			li = enemyList.listIterator();
				while (li.hasNext()){
					enemys en = li.next();
					if (en.isDying != true){
					pointA = new Point2D.Double(aff2.getTranslateX() + tower.getWidth() / 2 -
							shot.getWidth() / 2, aff2.getTranslateY() + tower.getHeight() / 2 - 
							shot.getHeight() / 2);
					pointB = new Point2D.Double(en.aff.getTranslateX() + 
							en.enemyImage.getIconWidth() - shot.getWidth() / 2, 
									en.aff.getTranslateY() + en.enemyImage.getIconHeight()
									/ 2 - shot.getHeight() / 2);
					if (whichStructure == "tower"){
							try {
								structureShot(pointA, pointB, bIL[12], 0);
							} catch (UnsupportedAudioFileException
									| IOException | LineUnavailableException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						break;
					}
					if (whichStructure == "speedTower"){
						try {
							structureShot(pointA, pointB, bIL[21], 4);
						} catch (UnsupportedAudioFileException | IOException
								| LineUnavailableException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						break;
					}
					if (whichStructure == "frostTower"){
						en.speedMinusFn = roundingMethod(en.speed - en.frostNumber);
						if (en.speedMinusFn > .1){
						try {
							structureShot(pointA, pointB, bIL[5], 1);
						} catch (UnsupportedAudioFileException | IOException
								| LineUnavailableException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						}
					}
					if (whichStructure == "poisenTower"){
						if (en.enemyNumber != 1){
						try {
							structureShot(pointA, pointB, bIL[3], 2);
						} catch (UnsupportedAudioFileException | IOException
								| LineUnavailableException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						poisenCount++;
						}
						if (poisenCount >= 28 || li.hasNext() != true){
						poisenCount = 0;
						break;
						}
					}
					if (whichStructure == "splashTower"){
						try {
							structureShot(pointA, pointB, bIL[1], 3);
						} catch (UnsupportedAudioFileException | IOException
								| LineUnavailableException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						break;
					}
				}
			}
		}
	}
	/** player tower shot object. 0 is basic, 1 is frost, two is poisen, three is splash and four is speed. */
	class towerShot implements ActionListener{
		/** true if the shot is exploding. splash tower only */
	Boolean isExploding;
	/** true if shot must be removed because it went off scren or hit an enemy. */
	Boolean needsRemoved;
	/** shot list. represent the four or five type of shot from tower. basic and or speed, poisen, splash and frost. */
	Integer whichShot;
	/** represent one of eight quadrent */
	Integer quadrent;
	Integer shotSpeed, whichFrame;
	/** shot transparent rectangle behind the shot image */
	Rectangle2D.Double rec;
	/** shot speed decimal relative to one */
	Double slope;
	Timer t;
	/** splash tower explosion rectangle */
	Rectangle2D.Double splashRec;
	Clip fireSound, hitSound, poisenedSound;
	@SuppressWarnings("deprecation")
	public towerShot(Rectangle2D.Double tsRec, double tsSlope, int tsQuadrent, int whichShot2)
			throws UnsupportedAudioFileException, IOException, LineUnavailableException{
		// basic or speed tower
	if (whichShot2 == 0|| whichShot2 == 4){
		fireSound = clickingPlayButtonArray[6];
		hitSound = clickingPlayButtonArray[10];
	}
	// frost
	if (whichShot2 == 1){
		fireSound = clickingPlayButtonArray[7];
		hitSound = clickingPlayButtonArray[11];
	}
	if (whichShot2 == 2){
		fireSound = clickingPlayButtonArray[8];
		hitSound = clickingPlayButtonArray[12];
		poisenedSound = clickingPlayButtonArray[13];
	}
	if (whichShot2 == 3){
		fireSound = clickingPlayButtonArray[9];
		hitSound = clickingPlayButtonArray[14];
	}
	if (sound){
	fireSound.start();
	}
	whichFrame = new Integer(28);
	shotSpeed = new Integer(8);
	needsRemoved = new Boolean(false);
	isExploding = new Boolean(false);
	t = new Timer(120, this);
	whichShot = new Integer(whichShot2);
	rec = new Rectangle2D.Double();
	rec = tsRec;
	slope = new Double(tsSlope);
	quadrent = new Integer(tsQuadrent);
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		whichFrame++;
		if (whichFrame == 32){
			needsRemoved = true;
			t.stop();
		}
	}
}
	/**
		 enemy class main method. may need to be re-writen; the parameter is a litle much.
		 * @param enemyaff the x and y location where the enemy is to be spawned
		 * @param enemynumbertwo which enemy to create. zero is peasent, one is bomb, two is horse rider, three is door smasher and four is level fifty six boss 
		 * @param goldaward the amount of gold to be awarded to player if the enemy die
		 * @param health enemy health amount
		 * @param speed enemy speed
		 * @param whichenemy enemy movement animation
		 * @param enemydeath enemy death animation
		 * @param enemyatacking enemy atack animation
		 * @param enemypoisened animation to be displayed if enemy is poisened. bomb enemy is imune to poisen but take extra damage from splash tower (fire)
		 * @param enemyfrozen enemy frozen animation
		 * @param enemyburning enemy burning animation
	 */
	class enemys extends TimerTask implements ActionListener{
		/** subtract enemy health is burning or poisened */
		Timer t;
		/** handle enemy animation */
		Timer t2;
		java.util.Timer t3;
		/** enemy location, rotation */
		AffineTransform aff;
		AffineTransform aff2;
		/** enemy moving, hurt, atacking animation */
		ImageIcon enemyImage, enemyDeath, enemyAttacking, enemyPoisened, enemyFrozen,
		enemyBurning, horseRetreating, sparks;
		/** rectangle behind enemy used for canon bal colision and gate detection */
		Rectangle2D.Double rec;
		/** enemy health */
		Integer health;
		/** amount of gold awarded to player when enemy die */
		Integer goldAward;
		/** which type of enemy was created zero through four. peasent, bomb, horse rider, door smasher and robot boss */
		Integer enemyNumber;
		Integer fourCount, whichFrame, deathDelay;
		/** true if this enemy has died or destroyed the gate and progresed ofscren. */
		Boolean flaggedForRemoval;
		Boolean isDying;
		/** true if this enemy is frozen. enemy speed increases by .1 after about level thirty which let frost tower shoot at them. */
		Boolean isFrozen;
		/** true if this enemy is poisened. bomb are imune to poisen. */
		Boolean isPoisened;
		/** true if this enemy was hit by splash tower and is not a bomb. */
		Boolean isBurning;
		/** true if this enemy exploded on the gate. bomb only */
		Boolean explodedOnGate;
		Boolean timerScheduled;
		/** amount of frost this enemy has been hit with by .1 */
		Double frostNumber;
		/** enemy speed starting at .1 */
		Double speed;
		/** enemy speed minus frost number */
		Double speedMinusFn;
		Clip attacking, dying;
		/** create a new enemy object. */
		public enemys(AffineTransform enemysAff, Integer enemyNumber2, Integer goldAward2, 
				Integer health2, Double speed2, ImageIcon whichEnemy, ImageIcon enemyDeath2,
				ImageIcon enemyAttacking2, ImageIcon enemyPoisened2, ImageIcon enemyFrozen2,
				ImageIcon enemyBurning2) throws UnsupportedAudioFileException, IOException,
				LineUnavailableException{
			aff2 = new AffineTransform();
			fourCount = new Integer(0);
			speed = new Double(speed2);
			speedMinusFn = speed;
			sparks = iIL[17];
			horseRetreating = iIL[11];
			enemyNumber = new Integer(enemyNumber2);
			if (enemyNumber == 0){
				attacking = clickingPlayButtonArray[15];
				dying = clickingPlayButtonArray[16];
				whichFrame = new Integer(32);
			}
			if (enemyNumber == 1){
				attacking = clickingPlayButtonArray[17];
				whichFrame = new Integer(36);
			}
			if (enemyNumber == 2){
				attacking = clickingPlayButtonArray[18];
				dying = clickingPlayButtonArray[19];
				whichFrame = new Integer(40);
			}
			if (enemyNumber == 3){
				attacking = clickingPlayButtonArray[20];
				dying = clickingPlayButtonArray[21];
				whichFrame = new Integer(44);
			}
			if (enemyNumber == 4){
				attacking = clickingPlayButtonArray[22];
				dying = clickingPlayButtonArray[23];
			}
			deathDelay = new Integer(0);
			frostNumber = new Double(0);
			goldAward = new Integer(goldAward2);
			enemyImage = whichEnemy;
			enemyDeath = enemyDeath2;
			enemyAttacking = enemyAttacking2;
			enemyPoisened = enemyPoisened2;
			enemyFrozen = enemyFrozen2;
			enemyBurning = enemyBurning2;
			explodedOnGate = new Boolean(false);
			isPoisened = new Boolean(false);
			rec = new Rectangle2D.Double(enemysAff.getTranslateX(), enemysAff.getTranslateY(), 
					whichEnemy.getIconWidth(), whichEnemy.getIconHeight());
			isFrozen = new Boolean(false);
			isBurning = new Boolean(false);
			health = new Integer(health2);
			t = new Timer(0, this);
			t2 = new Timer(120, this);
			t3 = new java.util.Timer();
			isDying = new Boolean(false);
			flaggedForRemoval = new Boolean(false);
			timerScheduled = new Boolean(false);
			aff = enemysAff;
		}
		@Override
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == t && !paused){
			health -= 1;
				if (isBurning && isPoisened){
					health -= 1;
				}
			}
			if (e.getSource() == t2){
				if (fourCount <= 2){
				whichFrame++;
				}
				if (fourCount != 4){
				fourCount++;
				}
				if (deathDelay == 48){
					t2.stop();
					flaggedForRemoval = true;
				}
				deathDelay++;
			}
		}
		@Override
		public void run() {
			// TODO Auto-generated method stub
			if (attacking.getLongFramePosition() == attacking.getFrameLength()){
				attacking.setFramePosition(0);
			}
			if (attacking.getLongFramePosition() == 0){
				if (sound){
			attacking.start();
				}
			}
		}
	}
	/** play sound. hover or click, shoot or die excetera */
	class hoverAndClickSounds{
		Clip clip;
		/** @param cliptwo clip to be played */
		public hoverAndClickSounds(Clip clip2) throws UnsupportedAudioFileException,
		IOException, LineUnavailableException{
			clip = clip2;
			if (sound){
			clip.start();
			}
		}
	}
}